<template>
  <div class="container-fluid">
    <div class="card mt-5">
        <div class="card-header">
            <span style="font-size: 20px;">Usuarios</span>
              <router-link exact-active-class="active" :to="{ name: 'users'}" :class="['btn btn-outline-primary pull-right mt-1']">
                  Atras
              </router-link> 
        </div>
        <div class="card-body">
          <form class="form-horizontal">
            <div class="form-group row" >
                <label class="col-md-3 form-control-label" for="text-input">Primer nombre</label>
                <div class="col-md-9">
                    <input type="text" v-model="user.first_name" class="form-control" placeholder="Nombre" >
                    <span v-if="allerrors.first_name" :class="['text-danger']">{{ allerrors.first_name[0] }}</span>
                </div>
            </div>
            <div class="form-group row" >
                <label class="col-md-3 form-control-label" for="text-input">Primer apellido</label>
                <div class="col-md-9">
                    <input type="text" v-model="user.last_name" class="form-control" placeholder="Nombre" >
                    <span v-if="allerrors.last_name" :class="['text-danger']">{{ allerrors.last_name[0] }}</span>
                </div>
            </div>
            <div class="form-group row" >
                <label class="col-md-3 form-control-label" for="text-input">Email</label>
                <div class="col-md-9">
                    <input v-if="user.id" type="email" v-model="user.email" class="form-control" placeholder="Email" readonly>
                    <input v-if="!user.id" type="email" v-model="user.email" class="form-control" placeholder="Email" >
                    <span v-if="allerrors.email" :class="['text-danger']">{{ allerrors.email[0] }}</span>
                </div>
            </div>
            <div class="form-group row">
                <label class="col-md-3 form-control-label" for="text-input">Rol</label>
                <div class="col-md-9">
                    <input v-if="user.id" type="text" v-model="user.role.name" class="form-control" readonly>
                    <multiselect v-if="!user.id" v-model="user.role" tag-placeholder="Add this as new tag" placeholder="Seleccione un rol" label="name" track-by="id" :options="roles" :multiple="false" :taggable="true"></multiselect>
                    <span v-if="allerrors.role" :class="['text-danger']">{{ allerrors.role[0] }}</span>
                </div> 
            </div>
            <div class="form-group row" >
                <label class="col-md-3 form-control-label" for="text-input">Contraseña</label>
                <div class="col-md-9">
                    <input type="password" v-model="user.password" class="form-control" placeholder="Contraseña" >
                    <span v-if="allerrors.password" :class="['text-danger']">{{ allerrors.password[0] }}</span>
                </div>
            </div>
            
            
          </form>
          <div class="modal-footer">
            <button v-if="!user.id" type="button" @click="create()" class="btn btn-primary">Crear</button>
            <button v-if="user.id" type="button" @click="update()" class="btn btn-primary">Actualizar</button>
          </div>
        </div>
    </div>
  </div>
</template>

<script>

export default {
  data() {
    return {
      allerrors: {},
      roles:[],
      user: {
        first_name: null,
        lasst_name: null,
        email: null,
        role: null,
        password: null,
      },
    };
  },
   
     
  methods: {
    getShowUser() {
      let _this = this;
      axios
        .get("/admin/user/show/" + _this.$route.params.id)
        .then(function(response) {
          
          _this.user = response.data;
          
          console.log(_this.user);
        });
    },
    getRoles(){
      let _this = this;
      axios .get("/admin/roles")
      .then(function(response) {
        _this.roles = response.data;
      });

    },
    create() {
      let _this = this;
      axios
        .post("/admin/user", _this.user)
        .then(function(response) {
          _this.allerrors = [];
          _this.$message.success("Se ha creado el aliado con exito.");
          _this.$router.push({ name: "users" });
        })
        .catch(function(error) {
          if (error.response && error.response.data) {
            _this.$message.error(
              "Ha ocurrido un error, verifique los campos del formulario."
            );
            _this.allerrors = error.response.data.errors;
          } else {
            console.log("error ProductFormComponent update", error);
          }
        });
    },
    update() {
      let _this = this;

      axios
        .put("/admin/user/"+ _this.$route.params.id, _this.user)
        .then(function(response) {
          _this.allerrors = [];
          _this.$message.success("Se ha actualizado el usuario con exito.");
          _this.$router.push({ name: "users" });
        })
        .catch(function(error) {
          if (error.response && error.response.data) {
            _this.$message.error(
              "Ha ocurrido un error, verifique los campos del formulario."
            );
            _this.allerrors = error.response.data.errors;
          } else {
            console.log("error UserFormComponent update", error);
          }
        });
    }
  },
  mounted() {
    if (this.$route.params.id > 0) {
      this.getShowUser()
    }
    this.getRoles();
  }
};
</script>